/*
	CingularMinutesMinder
	cingular.js
	Author: Matt Zollinhofer
	Date: 7/12/06
	Version: 0.1
	cingularminutes@gmail.com
	
	Thanks to Winston Huang, parts of this extension based on his T-Mobile extension.
	
	License:
	  Permission is hereby granted, free of charge, to any person obtaining
      a copy of this software and associated documentation files (the
      "Software"), to deal in the Software without restriction, including
      without limitation the rights to use, copy, modify, merge, publish,
      distribute, sublicense, and/or sell copies of the Software, and to
      permit persons to whom the Software is furnished to do so, subject to
      the following conditions:
      
      The above copyright notice and this permission notice shall be
      included in all copies or substantial portions of the Software.
      
      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
      EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
      MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
      NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
      LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
      OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
      WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
      	
*/

var cingularPrefVal = "http://minuteMinder.cingular.com";
var initialRequest;
var minutesRequest;
var minutesRequest1;
var ASYNC = true;
var number = "";
var areaCode = "";
var prefix = "";
var lastFour = "";
var alreadyPromptedForPassword = false;

function cingularInit() 
{
	window.addEventListener( "load", windowLoad, false );
}

/*
	Executed anytime a new Firefox window is opened.
	Checks the last checked date, if old, recheck,
	otherwise just use the value stored.
*/
function windowLoad()
{
/*	
	if ( true )
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		if ( (prefs.getPrefType("extensions.cingularMinutesMinder.minutesRemaining") == prefs.PREF_STRING)
				&& (prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining")) )
		{
			var minRemainingLabel = document.getElementById('cingularMinutesRemaining');
			if (minRemainingLabel)
			{
				minRemainingLabel.value = prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining");
			}
		}
	}
*/
	getCingularMinutes();

}

/*
	1. get the number and password
	2. break the number up into pieces
	3. get the last time checked from firefox's user prefs (about:config)
	4. set loading image
	5. set last time checked
	6. send initial request
*/
function getCingularMinutes()
{
	var data = getCingularLoginData();
	number = data.login;
	areaCode = number.substring(0,3);
	prefix = number.substring(3,6);
	lastFour = number.substring(6,10);
	
	if ( (number != "") && (data.password != null) )
	{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var today = new Date();
		var lastChecked;

		if (prefs.getPrefType("extensions.cingularMinutesMinder.lastTimeChecked") == prefs.PREF_STRING)
		{
			lastChecked = prefs.getCharPref("extensions.cingularMinutesMinder.lastTimeChecked");
		}
		
//		put this back in if you want to only check it once per day (effectively caching)
		if ( (lastChecked == null) || (lastChecked < today.getTime()) )
		{
			var image = document.getElementById("cingularImage");
			image.src="chrome://cingularminutes/content/loading.gif";

			today.setHours(23);
			today.setMinutes(59);
			today.setSeconds(59);
			prefs.setCharPref("extensions.cingularMinutesMinder.lastTimeChecked", today.getTime() );

			initialRequest = new XMLHttpRequest();
//			initialRequest.open("POST", "https://www.myaccount.cingular.com/olam/loginAction.action", ASYNC);
			initialRequest.open("POST", "https://www.myaccount.cingular.com/olam/loginAction.doview", ASYNC);
			initialRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			if (ASYNC)
			{
				initialRequest.onload = handleInitialResponse;
			}
		
			var req;
			//the old login process
			//req="actionEvent=loginInProgress&IDToken1="+number+"&ctnAreaCode="+areaCode+"&ctnPrefix="+prefix+"&ctnNumber="+lastFour+"&pass="+data.password+"&x=0&y=0";
			req="actionEvent=loginInProgress&wireless_num="+data.login+"&pass="+data.password+"&x=26&y=9";
			initialRequest.send(req);
		}
		else
		{
			if ( prefs.getPrefType("extensions.cingularMinutesMinder.minutesRemaining") == prefs.PREF_STRING );
			{
				document.getElementById('cingularMinutesRemaining').value = prefs.getCharPref("extensions.cingularMinutesMinder.minutesRemaining");
			}
		}

	}
	else
	{
		if ( !alreadyPromptedForPassword )
		{
			alreadyPromptedForPassword = true;
			window.open("chrome://cingularminutes/content/cingularPreferences.xul", "Preferences", "chrome,centerscreen,modal");
			getCingularMinutes();
		}
		else
		{
			alreadyPromptedForPassword = false;
		}
	}
}


/* 
	cingular's login process is two steps,
	this method handles the response to the first
	step.  It immediately sends another request which
	brings us to the right page, this is handled 
	in the 'handleMinutesResponse()' function
*/
function handleInitialResponse()
{
	minutesRequest = new XMLHttpRequest();
	minutesRequest.open("POST", "https://www.myaccount.cingular.com/olam/loginAction.action", ASYNC);
	minutesRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	if (ASYNC)
	{
		minutesRequest.onload = handleMinutesResponse;
	}
	var req;
	req="actionEvent=login&reportActionEvent=A_LGN_LOGIN_SUB&ctnAreaCode="+areaCode+"&ctnPrefix="+prefix+"&ctnNumber="+lastFour+"&customerType=";

	minutesRequest.send(req);
}

/*
	gets the minutes from the second request's response text.
*/
function handleMinutesResponse()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var text = minutesRequest.responseText;
	var idx1;
	var idx2;
	var tableStartIdx;
	var tableEndIdx;
	var toolTipText = "";
	var anytimeMinutesRemaining = "";
	var rowArray = new Array();
	
	idx1 = text.indexOf('CURRENT USAGE');
	if ( idx1 > -1 )
	{
		text = text.substring(idx1);
		tableStartIdx = text.indexOf('<table');
		tableEndIdx = text.indexOf('</table>');
		text = text.substring(tableStartIdx, tableEndIdx+7);
		var rows = getRows(text);
		rowCount = 1;
		var minuteTypeCount = 0;
		var toolTipArray = new Array();
		
		//don't start at 0 because the first row is just a link
		//after that every 3 rows make up one type of service
		for ( var i=1; i < rows.length; i++ )
		{
			if ( rowCount == 1 )
			{
				rowArray = new Array();
			}
			switch (rowCount)
			{
				//the first row has the minute type (Anytime, Nights/Weekends, etc.)
				case 1:
					var regStr = "<td[\\s\\S]*?>([\\s\\S]*?)</td>";
					var regExp = new RegExp(regStr);
					var cellData = regExp.exec(rows[i]);
					var minuteType = "";
					if ( cellData )
					{
						minuteType = cellData[1];
						toolTipText += minuteType +": ";
					}
					rowArray[0] = minuteType;
					break;
					
				//second row is the graph, maybe useful later
				case 2:
					break;
				
				//third row has the number of minutes used and total number of minutes
				case 3:
					var regStr = "<td[\\s\\S]*?>([\\s\\S]*?)</td>";
					var regExp = new RegExp(regStr);
					var cellData = regExp.exec(rows[i]);
					if ( cellData )
					{
						//take all the commas out of the numbers
						var data = cellData[1].replace(",","");

						//minutes will have all the numbers out the cellData
						regStr = "\\s([\\d]+)\\s";
						var minutes = getAllMatches(data+" ", regStr);
						var remainingMinutes = "";
						switch (minutes.length)
						{
							//if there are 0 numbers, don't do anything
							case 0:
								rowArray[1] = rowArray[2] = rowArray[3] = "";
								break;
								
							//if there is 1 number, check to see if it's unlimited or n/a, if not don't do anything
							case 1:
								if ( data.toLowerCase().indexOf('unlimited') > -1 )
									remainingMinutes = "Unlimited";
								else if ( data.toLowerCase().indexOf('n/a') > -1 )
									remainingMinutes = "N/A";
									
								rowArray[1] = minutes[0];
								rowArray[2] = rowArray[3] = remainingMinutes;
								break;
								
							//if there are 2 numbers, subtract them to get the number of remaining minutes
							case 2:
								remainingMinutes = (minutes[1]-minutes[0]);
								rowArray[1] = minutes[0];
								rowArray[2] = minutes[1];
								rowArray[3] = remainingMinutes;
								break;
								
						}
						toolTipText += remainingMinutes+"\n";

					}
					rowCount = 0;
					minuteTypeCount++;
					break;
			}
			
			//this is what we display on the status bar
			if ( rowArray[0] && rowArray[0].toLowerCase() == "anytime" )
			{
				anytimeMinutesRemaining = rowArray[3];
			}
			
			//if the length is 4, then we have a full array for the toolTipArray
			//until it gets to 4 it's still building the data
			if ( rowArray.length == 4 )
			{
				toolTipArray[toolTipArray.length] = rowArray;
			}
			rowCount++;
		}
		document.getElementById('cingularImage').toolTipText = toolTipText;
	}
	
	//set the status bar display text
	var remainingMinutesLabel = document.getElementById("cingularMinutesRemaining");
	remainingMinutesLabel.value = anytimeMinutesRemaining;
	prefs.setCharPref("extensions.cingularMinutesMinder.minutesRemaining", anytimeMinutesRemaining);
	//set the tooltip
	createToolTip ( toolTipArray );

	// stop the loading image, put it back to normal
	var image = document.getElementById("cingularImage");
	image.src="chrome://cingularminutes/content/cingular.gif";
	
	
}

/*
	Returns an array of the strings in str that matched the string regStr
*/
function getAllMatches(str, regStr)
{
	var allMatches = new Array();
	regExp = new RegExp(regStr);
	var idx = 0;

	while ( idx > -1 )
	{
		match = regExp.exec(str);
		if ( match != null )
		{
			idx = match.index;
			allMatches[allMatches.length] = match[1];
			str = str.substring( idx+match[0].length-1 );
		}
		else
		{
			idx = -1;
		}
	}
	return allMatches;
}


/*
	returns an array of the data inside the <tr>s that are passed to it
*/
function getRows(text)
{
	var rows = new Array();
	var count = 0;
	var idx = text.indexOf('<tr>');
	while ( idx > -1 )
	{
		rows[count] = text.substring(text.indexOf('<tr>')+5, text.indexOf('</tr>', text.indexOf('<tr>')+5) );
		count++;
		text = text.substring(idx+1);
		idx = text.indexOf('<tr>');
	}
	
	return rows;
}


/*
	strips all non-digit characters and sets the userID/password
	in FF password manager
*/
function setCingularLoginData( userID, password )
{

	var userID = userID.replace(new RegExp("[^0-9]","g"),"");
	var passMgr = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
	try 
	{
		passMgr.addUserFull( cingularPrefVal, userID, password, '', '', '');
	} catch (err) 
	{
		alert("didn't save the userid/password:\n"+err);
	}
}

/*
	gets userID and password from FF's password manager
*/
function getCingularLoginData()
{
    var data = {login: "", password: ""};
	var host = {value: "http://minuteMinder.cingular.com"}, user = {value: ""}, password = {value: ""};

	var mypassMgr = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);
	try 
	{
		mypassMgr.findPasswordEntry( host.value, '', '', host, user, password ); 
		data.login = user.value;
		data.password = password.value;
	} 
	catch (err) 
	{
		alert("no user/password retrieved from the password manager");
	}

	return data;
}

function createToolTip( dataArray )
{
	var grid = document.createElement("grid");
	grid.setAttribute("id","cingularToolTipGrid");
	
	//create and append columns
	var columns = createColumns();
	grid.appendChild(columns);
	
	//create and append heading
	var rows = document.createElement("rows");
	var minuteHeadingRow = createMinuteHeadingRow();
	rows.appendChild(minuteHeadingRow);

/*
	//test dataArray
	var dataArray = new Array(
								new Array("Anytime","350","900","600"), 
								new Array("Mobile To Mobile","299","1000","701"),
								new Array("Nights & Weekends","252","Unlimited","Unlimited"),
								new Array("Overage","252","N/A","N/A")
							 );
*/
	//create and append data rows
	var minuteDataRows = createMinuteDataRows(dataArray);
	for ( var i=0; i<minuteDataRows.length; i++ )
	{
		rows.appendChild(minuteDataRows[i]);
	}
	grid.appendChild(rows);
	
	var tooltip = document.createElement('tooltip');
	tooltip.setAttribute('id','cingularToolTip');
	tooltip.setAttribute("noautohide", true);
	tooltip.setAttribute("orient", "vertical");
	tooltip.appendChild(grid);
		
	mainPopup = document.getElementById("mainPopupSet");
	mainPopup.appendChild(tooltip);
	var statusPanel = document.getElementById('cingularStatusPanel');
	statusPanel.setAttribute('tooltip',"cingularToolTip");
}

function createColumns()
{
	var columns = document.createElement("columns");
	var column1 = document.createElement("column");
	var column2 = document.createElement("column");
	var column3 = document.createElement("column");
	var column4 = document.createElement("column");
	column1.setAttribute("flex","1");
	columns.appendChild(column1);
	columns.appendChild(column2);
	columns.appendChild(column3);
	columns.appendChild(column4);
	return columns;
}

function createMinuteHeadingRow()
{
	var headingRow = document.createElement("row");
	headingRow.setAttribute("class","headingRow");
	var heading1 = document.createElement('label');
	heading1.setAttribute("value","Types");
	heading1.setAttribute('class','heading typesHeading');
	var heading2 = document.createElement('label');
	heading2.setAttribute("value","Used");
	heading2.setAttribute('class','heading');
	var heading3 = document.createElement('label');
	heading3.setAttribute("value","Allowed");
	heading3.setAttribute('class','heading');
	var heading4 = document.createElement('label');
	heading4.setAttribute("value","Remaining");
	heading4.setAttribute('class','heading');
	headingRow.appendChild(heading1);
	headingRow.appendChild(heading2);
	headingRow.appendChild(heading3);
	headingRow.appendChild(heading4);
	return headingRow;
}

function createMinuteDataRows(minuteData)
{
	var minutesRows = new Array();
	
	for ( var i=0; i<minuteData.length; i++ )
	{
		var row = document.createElement("row");
		if ( (i % 2) == 0 )
		{
			row.setAttribute("class","stripe");
		}
		rowData = minuteData[i];
		for ( var j=0; j<rowData.length; j++ )
		{
			var element = createDataLabel(rowData[j]);
			if ( j == 0 )
			{
				element.setAttribute('class','type');
			}
			row.appendChild(element);
		}
		minutesRows[i] = row;
	}
	return minutesRows;
}

function createDataLabel(data)
{
	var label = document.createElement('label');
	label.setAttribute('value',data);
	return label;
}

cingularInit();